#include <bits/stdc++.h>

using namespace std;

int a[20];
//int pomocni[20];
int vr[65];
int n;
//int snaga[20][6];
int mini = INT_MAX;

bool provera(int x)
{
    bool konj = false;
    bool dis = false;
    for(int i = 0; i < 5; i++)
    {
        if(vr[i] == n) konj = true;
        if(vr[i] % 2 == 1) dis = true;
        if(konj && dis) return true;
    }
    return false;
}

void podesi(int x, int y)
{
    for(int j = 0; j < 2; j++)
    {
        if((x & (1 << j)) && !(y & (1 << j))) vr[j]++;
        else if(!(x & (1 << j)) && (y & (1 << j))) vr[j]--;
    }
}


void rek(int l, int d, int x)
{
    if(l == d)
    {
        if(provera(x)) mini = min(mini, x);
        if(mini == 1) {cout << "1"; exit(0);}
        return;
    }

    rek(l + 1, d, x);
    int pom = a[l];

    if(a[l] > 0)
    {
        a[l]--;
        podesi(a[l], pom);
        rek(l + 1, d, x+1);

        a[l]+=2;
        podesi(a[l] - 2, a[l]);
        rek(l + 1, d, x+1);
    }
    else
    {
        a[l]++;
        podesi(pom, a[l]);
        rek(l + 1, d, x+1);
    }


}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);


    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
        for(int j = 0; j < 6; j++)
        {
            if(a[i] & (1 << j)) vr[j]++;
        }
    }

    rek(0, n, 0);
    cout << mini;




    return 0;
}